## org.apache.poi.hssf.record
Class RecalcIdRecord

    java.lang.Object
      org.apache.poi.hssf.record.Record
          org.apache.poi.hssf.record.RecalcIdRecord

public class RecalcIdRecord
extends Record

Title: Recalc Id Record

Description: This record contains an ID that marks when a worksheet was last recalculated. It's an optimization Excel uses to determine if it needs to recalculate the spreadsheet when it's opened. So far, only the two values `0xC1 0x01 0x00 0x00 0x80 0x38 0x01 0x00` (do not recalculate) and `0xC1 0x01 0x00 0x00 0x60 0x69 0x01 0x00` have been seen. If the field `isNeeded` is set to false (default), then this record is swallowed during the serialization process

REFERENCE: http://chicago.sourceforge.net/devel/docs/excel/biff8.html

Version:
  2.0-pre
Author:
  Luc Girardin (luc dot girardin at macrofocus dot com)
See Also:
  `Workbook`

Field Summary
`short[]` `field_1_recalcids`
`static short` `sid`

Constructor Summary
`RecalcIdRecord()`
`RecalcIdRecord(short id, short size, byte[] data)` Constructs a RECALCID record and sets its fields appropriately.
`RecalcIdRecord(short id, short size, byte[] data, int offset)` Constructs a RECALCID record and sets its fields appropriately.

Method Summary
`protected void` `fillFields(byte[] data, short size, int offset)` called by the constructor, should set class level fields.
`short[]` `getRecalcIdArray()` get the recalc array.
`int` `getRecordSize()` gives the current serialized size of the record.
`short` `getSid()` return the non static version of the id for this record.
`boolean` `isNeeded()`
`int` `serialize(int offset, byte[] data)` called by the class that is responsible for writing this sucker.
`void` `setIsNeeded(boolean isNeeded)`
`void` `setRecalcIdArray(short[] array)` set the recalc array.
`java.lang.String` `toString()` get a string representation of the record (for biffview/debugging)
`protected void` `validateSid(short id)` called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

Methods inherited from class org.apache.poi.hssf.record.Record
`clone, fillFields, isInValueSection, isValue, processContinueRecord, serialize`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### sid

    public static final short sid

See Also:
  Constant Field Values

### field_1_recalcids

    public short[] field_1_recalcids

Constructor Detail

### RecalcIdRecord

    public RecalcIdRecord()

### RecalcIdRecord

    public RecalcIdRecord(short id,
                          short size,
                          byte[] data)

  Constructs a RECALCID record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x13d or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)

### RecalcIdRecord

    public RecalcIdRecord(short id,
                          short size,
                          byte[] data,
                          int offset)

  Constructs a RECALCID record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x13d or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)
  `offset` - of the record

Method Detail

### validateSid

    protected void validateSid(short id)

  Description copied from class: `Record`
  called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

  Specified by:
    `validateSid` in class `Record`
  Parameters:
    `id` - alleged id for this record

### fillFields

    protected void fillFields(byte[] data,
                              short size,
                              int offset)

  Description copied from class: `Record`
  called by the constructor, should set class level fields. Should throw runtime exception for bad/icomplete data.

  Specified by:
    `fillFields` in class `Record`
  Parameters:
    `data` - raw data
    `size` - size of data
    `offset` - of the record's data (provided a big array of the file)

### setRecalcIdArray

    public void setRecalcIdArray(short[] array)

  set the recalc array.

  Parameters:
    `array` - of recalc id's

### getRecalcIdArray

    public short[] getRecalcIdArray()

  get the recalc array.

  Returns:
    array of recalc id's

### setIsNeeded

    public void setIsNeeded(boolean isNeeded)

### isNeeded

    public boolean isNeeded()

### toString

    public java.lang.String toString()

  Description copied from class: `Record`
  get a string representation of the record (for biffview/debugging)

  Overrides:
    `toString` in class `Record`

### serialize

    public int serialize(int offset,
                         byte[] data)

  Description copied from class: `Record`
  called by the class that is responsible for writing this sucker. Subclasses should implement this so that their data is passed back in a byte array.

  Specified by:
    `serialize` in class `Record`
  Parameters:
    `offset` - to begin writing at
    `data` - byte array containing instance data
  Returns:
    number of bytes written

### getRecordSize

    public int getRecordSize()

  Description copied from class: `Record`
  gives the current serialized size of the record. Should include the sid and reclength (4 bytes).

  Overrides:
    `getRecordSize` in class `Record`

### getSid

    public short getSid()

  Description copied from class: `Record`
  return the non static version of the id for this record.

  Specified by:
    `getSid` in class `Record`

Copyright © 2003 Apache Software Foundation.